Index: src/unittests/ShapeUnittest.cpp
===================================================================
--- src/unittests/ShapeUnittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/unittests/ShapeUnittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,372 @@
+/*
+ * ShapeUnittest.cpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "ShapeUnittest.hpp"
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <cmath>
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+#include "LinearAlgebra/Vector.hpp"
+#include "Shapes/Shape.hpp"
+
+#include "Shapes/BaseShapes.hpp"
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( ShapeUnittest );
+
+void ShapeUnittest::setUp()
+{
+  v000 =  0*e1+0*e2+0*e3;
+  v100 =  1*e1+0*e2+0*e3;
+  v200 = -1*e1+0*e2+0*e3;
+  v010 =  0*e1+1*e2+0*e3;
+  v110 =  1*e1+1*e2+0*e3;
+  v210 = -1*e1+1*e2+0*e3;
+  v020 =  0*e1-1*e2+0*e3;
+  v120 =  1*e1-1*e2+0*e3;
+  v220 = -1*e1-1*e2+0*e3;
+  v001 =  0*e1+0*e2+1*e3;
+  v101 =  1*e1+0*e2+1*e3;
+  v201 = -1*e1+0*e2+1*e3;
+  v011 =  0*e1+1*e2+1*e3;
+  v111 =  1*e1+1*e2+1*e3;
+  v211 = -1*e1+1*e2+1*e3;
+  v021 =  0*e1-1*e2+1*e3;
+  v121 =  1*e1-1*e2+1*e3;
+  v221 = -1*e1-1*e2+1*e3;
+  v002 =  0*e1+0*e2-1*e3;
+  v102 =  1*e1+0*e2-1*e3;
+  v202 = -1*e1+0*e2-1*e3;
+  v012 =  0*e1+1*e2-1*e3;
+  v112 =  1*e1+1*e2-1*e3;
+  v212 = -1*e1+1*e2-1*e3;
+  v022 =  0*e1-1*e2-1*e3;
+  v122 =  1*e1-1*e2-1*e3;
+  v222 = -1*e1-1*e2-1*e3;
+}
+
+void ShapeUnittest::tearDown()
+{}
+
+
+void ShapeUnittest::baseShapesTest(){
+  CPPUNIT_ASSERT(!Nowhere().isInside(v000));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v100));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v200));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v010));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v110));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v210));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v020));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v120));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v220));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v001));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v101));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v201));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v011));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v111));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v211));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v021));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v121));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v221));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v002));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v102));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v202));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v012));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v112));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v212));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v022));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v122));
+  CPPUNIT_ASSERT(!Nowhere().isInside(v222));
+
+  CPPUNIT_ASSERT(Everywhere().isInside(v000));
+  CPPUNIT_ASSERT(Everywhere().isInside(v100));
+  CPPUNIT_ASSERT(Everywhere().isInside(v200));
+  CPPUNIT_ASSERT(Everywhere().isInside(v010));
+  CPPUNIT_ASSERT(Everywhere().isInside(v110));
+  CPPUNIT_ASSERT(Everywhere().isInside(v210));
+  CPPUNIT_ASSERT(Everywhere().isInside(v020));
+  CPPUNIT_ASSERT(Everywhere().isInside(v120));
+  CPPUNIT_ASSERT(Everywhere().isInside(v220));
+  CPPUNIT_ASSERT(Everywhere().isInside(v001));
+  CPPUNIT_ASSERT(Everywhere().isInside(v101));
+  CPPUNIT_ASSERT(Everywhere().isInside(v201));
+  CPPUNIT_ASSERT(Everywhere().isInside(v011));
+  CPPUNIT_ASSERT(Everywhere().isInside(v111));
+  CPPUNIT_ASSERT(Everywhere().isInside(v211));
+  CPPUNIT_ASSERT(Everywhere().isInside(v021));
+  CPPUNIT_ASSERT(Everywhere().isInside(v121));
+  CPPUNIT_ASSERT(Everywhere().isInside(v221));
+  CPPUNIT_ASSERT(Everywhere().isInside(v002));
+  CPPUNIT_ASSERT(Everywhere().isInside(v102));
+  CPPUNIT_ASSERT(Everywhere().isInside(v202));
+  CPPUNIT_ASSERT(Everywhere().isInside(v012));
+  CPPUNIT_ASSERT(Everywhere().isInside(v112));
+  CPPUNIT_ASSERT(Everywhere().isInside(v212));
+  CPPUNIT_ASSERT(Everywhere().isInside(v022));
+  CPPUNIT_ASSERT(Everywhere().isInside(v122));
+  CPPUNIT_ASSERT(Everywhere().isInside(v222));
+}
+
+void ShapeUnittest::assignmentTest(){
+  Shape s1 = Nowhere();
+  s1 = Everywhere();
+
+  CPPUNIT_ASSERT(s1.isInside(v000));
+  CPPUNIT_ASSERT(s1.isInside(v100));
+  CPPUNIT_ASSERT(s1.isInside(v200));
+  CPPUNIT_ASSERT(s1.isInside(v010));
+  CPPUNIT_ASSERT(s1.isInside(v110));
+  CPPUNIT_ASSERT(s1.isInside(v210));
+  CPPUNIT_ASSERT(s1.isInside(v020));
+  CPPUNIT_ASSERT(s1.isInside(v120));
+  CPPUNIT_ASSERT(s1.isInside(v220));
+  CPPUNIT_ASSERT(s1.isInside(v001));
+  CPPUNIT_ASSERT(s1.isInside(v101));
+  CPPUNIT_ASSERT(s1.isInside(v201));
+  CPPUNIT_ASSERT(s1.isInside(v011));
+  CPPUNIT_ASSERT(s1.isInside(v111));
+  CPPUNIT_ASSERT(s1.isInside(v211));
+  CPPUNIT_ASSERT(s1.isInside(v021));
+  CPPUNIT_ASSERT(s1.isInside(v121));
+  CPPUNIT_ASSERT(s1.isInside(v221));
+  CPPUNIT_ASSERT(s1.isInside(v002));
+  CPPUNIT_ASSERT(s1.isInside(v102));
+  CPPUNIT_ASSERT(s1.isInside(v202));
+  CPPUNIT_ASSERT(s1.isInside(v012));
+  CPPUNIT_ASSERT(s1.isInside(v112));
+  CPPUNIT_ASSERT(s1.isInside(v212));
+  CPPUNIT_ASSERT(s1.isInside(v022));
+  CPPUNIT_ASSERT(s1.isInside(v122));
+  CPPUNIT_ASSERT(s1.isInside(v222));
+
+  Shape s2 = Everywhere();
+  s2 = Nowhere();
+
+  CPPUNIT_ASSERT(!s2.isInside(v000));
+  CPPUNIT_ASSERT(!s2.isInside(v100));
+  CPPUNIT_ASSERT(!s2.isInside(v200));
+  CPPUNIT_ASSERT(!s2.isInside(v010));
+  CPPUNIT_ASSERT(!s2.isInside(v110));
+  CPPUNIT_ASSERT(!s2.isInside(v210));
+  CPPUNIT_ASSERT(!s2.isInside(v020));
+  CPPUNIT_ASSERT(!s2.isInside(v120));
+  CPPUNIT_ASSERT(!s2.isInside(v220));
+  CPPUNIT_ASSERT(!s2.isInside(v001));
+  CPPUNIT_ASSERT(!s2.isInside(v101));
+  CPPUNIT_ASSERT(!s2.isInside(v201));
+  CPPUNIT_ASSERT(!s2.isInside(v011));
+  CPPUNIT_ASSERT(!s2.isInside(v111));
+  CPPUNIT_ASSERT(!s2.isInside(v211));
+  CPPUNIT_ASSERT(!s2.isInside(v021));
+  CPPUNIT_ASSERT(!s2.isInside(v121));
+  CPPUNIT_ASSERT(!s2.isInside(v221));
+  CPPUNIT_ASSERT(!s2.isInside(v002));
+  CPPUNIT_ASSERT(!s2.isInside(v102));
+  CPPUNIT_ASSERT(!s2.isInside(v202));
+  CPPUNIT_ASSERT(!s2.isInside(v012));
+  CPPUNIT_ASSERT(!s2.isInside(v112));
+  CPPUNIT_ASSERT(!s2.isInside(v212));
+  CPPUNIT_ASSERT(!s2.isInside(v022));
+  CPPUNIT_ASSERT(!s2.isInside(v122));
+  CPPUNIT_ASSERT(!s2.isInside(v222));
+
+}
+
+void ShapeUnittest::operatorTest(){
+  {
+    Shape s1 = !Nowhere();
+    CPPUNIT_ASSERT(s1.isInside(v000));
+    CPPUNIT_ASSERT(s1.isInside(v100));
+    CPPUNIT_ASSERT(s1.isInside(v200));
+    CPPUNIT_ASSERT(s1.isInside(v010));
+    CPPUNIT_ASSERT(s1.isInside(v110));
+    CPPUNIT_ASSERT(s1.isInside(v210));
+    CPPUNIT_ASSERT(s1.isInside(v020));
+    CPPUNIT_ASSERT(s1.isInside(v120));
+    CPPUNIT_ASSERT(s1.isInside(v220));
+    CPPUNIT_ASSERT(s1.isInside(v001));
+    CPPUNIT_ASSERT(s1.isInside(v101));
+    CPPUNIT_ASSERT(s1.isInside(v201));
+    CPPUNIT_ASSERT(s1.isInside(v011));
+    CPPUNIT_ASSERT(s1.isInside(v111));
+    CPPUNIT_ASSERT(s1.isInside(v211));
+    CPPUNIT_ASSERT(s1.isInside(v021));
+    CPPUNIT_ASSERT(s1.isInside(v121));
+    CPPUNIT_ASSERT(s1.isInside(v221));
+    CPPUNIT_ASSERT(s1.isInside(v002));
+    CPPUNIT_ASSERT(s1.isInside(v102));
+    CPPUNIT_ASSERT(s1.isInside(v202));
+    CPPUNIT_ASSERT(s1.isInside(v012));
+    CPPUNIT_ASSERT(s1.isInside(v112));
+    CPPUNIT_ASSERT(s1.isInside(v212));
+    CPPUNIT_ASSERT(s1.isInside(v022));
+    CPPUNIT_ASSERT(s1.isInside(v122));
+    CPPUNIT_ASSERT(s1.isInside(v222));
+
+    Shape s2 = !Everywhere();
+    CPPUNIT_ASSERT(!s2.isInside(v000));
+    CPPUNIT_ASSERT(!s2.isInside(v100));
+    CPPUNIT_ASSERT(!s2.isInside(v200));
+    CPPUNIT_ASSERT(!s2.isInside(v010));
+    CPPUNIT_ASSERT(!s2.isInside(v110));
+    CPPUNIT_ASSERT(!s2.isInside(v210));
+    CPPUNIT_ASSERT(!s2.isInside(v020));
+    CPPUNIT_ASSERT(!s2.isInside(v120));
+    CPPUNIT_ASSERT(!s2.isInside(v220));
+    CPPUNIT_ASSERT(!s2.isInside(v001));
+    CPPUNIT_ASSERT(!s2.isInside(v101));
+    CPPUNIT_ASSERT(!s2.isInside(v201));
+    CPPUNIT_ASSERT(!s2.isInside(v011));
+    CPPUNIT_ASSERT(!s2.isInside(v111));
+    CPPUNIT_ASSERT(!s2.isInside(v211));
+    CPPUNIT_ASSERT(!s2.isInside(v021));
+    CPPUNIT_ASSERT(!s2.isInside(v121));
+    CPPUNIT_ASSERT(!s2.isInside(v221));
+    CPPUNIT_ASSERT(!s2.isInside(v002));
+    CPPUNIT_ASSERT(!s2.isInside(v102));
+    CPPUNIT_ASSERT(!s2.isInside(v202));
+    CPPUNIT_ASSERT(!s2.isInside(v012));
+    CPPUNIT_ASSERT(!s2.isInside(v112));
+    CPPUNIT_ASSERT(!s2.isInside(v212));
+    CPPUNIT_ASSERT(!s2.isInside(v022));
+    CPPUNIT_ASSERT(!s2.isInside(v122));
+    CPPUNIT_ASSERT(!s2.isInside(v222));
+  }
+
+  {
+    Shape s1 = Nowhere() || Everywhere();
+    CPPUNIT_ASSERT(s1.isInside(v000));
+    CPPUNIT_ASSERT(s1.isInside(v100));
+    CPPUNIT_ASSERT(s1.isInside(v200));
+    CPPUNIT_ASSERT(s1.isInside(v010));
+    CPPUNIT_ASSERT(s1.isInside(v110));
+    CPPUNIT_ASSERT(s1.isInside(v210));
+    CPPUNIT_ASSERT(s1.isInside(v020));
+    CPPUNIT_ASSERT(s1.isInside(v120));
+    CPPUNIT_ASSERT(s1.isInside(v220));
+    CPPUNIT_ASSERT(s1.isInside(v001));
+    CPPUNIT_ASSERT(s1.isInside(v101));
+    CPPUNIT_ASSERT(s1.isInside(v201));
+    CPPUNIT_ASSERT(s1.isInside(v011));
+    CPPUNIT_ASSERT(s1.isInside(v111));
+    CPPUNIT_ASSERT(s1.isInside(v211));
+    CPPUNIT_ASSERT(s1.isInside(v021));
+    CPPUNIT_ASSERT(s1.isInside(v121));
+    CPPUNIT_ASSERT(s1.isInside(v221));
+    CPPUNIT_ASSERT(s1.isInside(v002));
+    CPPUNIT_ASSERT(s1.isInside(v102));
+    CPPUNIT_ASSERT(s1.isInside(v202));
+    CPPUNIT_ASSERT(s1.isInside(v012));
+    CPPUNIT_ASSERT(s1.isInside(v112));
+    CPPUNIT_ASSERT(s1.isInside(v212));
+    CPPUNIT_ASSERT(s1.isInside(v022));
+    CPPUNIT_ASSERT(s1.isInside(v122));
+    CPPUNIT_ASSERT(s1.isInside(v222));
+
+    Shape s2 = Nowhere() && Everywhere();
+    CPPUNIT_ASSERT(!s2.isInside(v000));
+    CPPUNIT_ASSERT(!s2.isInside(v100));
+    CPPUNIT_ASSERT(!s2.isInside(v200));
+    CPPUNIT_ASSERT(!s2.isInside(v010));
+    CPPUNIT_ASSERT(!s2.isInside(v110));
+    CPPUNIT_ASSERT(!s2.isInside(v210));
+    CPPUNIT_ASSERT(!s2.isInside(v020));
+    CPPUNIT_ASSERT(!s2.isInside(v120));
+    CPPUNIT_ASSERT(!s2.isInside(v220));
+    CPPUNIT_ASSERT(!s2.isInside(v001));
+    CPPUNIT_ASSERT(!s2.isInside(v101));
+    CPPUNIT_ASSERT(!s2.isInside(v201));
+    CPPUNIT_ASSERT(!s2.isInside(v011));
+    CPPUNIT_ASSERT(!s2.isInside(v111));
+    CPPUNIT_ASSERT(!s2.isInside(v211));
+    CPPUNIT_ASSERT(!s2.isInside(v021));
+    CPPUNIT_ASSERT(!s2.isInside(v121));
+    CPPUNIT_ASSERT(!s2.isInside(v221));
+    CPPUNIT_ASSERT(!s2.isInside(v002));
+    CPPUNIT_ASSERT(!s2.isInside(v102));
+    CPPUNIT_ASSERT(!s2.isInside(v202));
+    CPPUNIT_ASSERT(!s2.isInside(v012));
+    CPPUNIT_ASSERT(!s2.isInside(v112));
+    CPPUNIT_ASSERT(!s2.isInside(v212));
+    CPPUNIT_ASSERT(!s2.isInside(v022));
+    CPPUNIT_ASSERT(!s2.isInside(v122));
+    CPPUNIT_ASSERT(!s2.isInside(v222));
+  }
+
+  {
+    Shape s1 = Everywhere() || Nowhere();
+    CPPUNIT_ASSERT(s1.isInside(v000));
+    CPPUNIT_ASSERT(s1.isInside(v100));
+    CPPUNIT_ASSERT(s1.isInside(v200));
+    CPPUNIT_ASSERT(s1.isInside(v010));
+    CPPUNIT_ASSERT(s1.isInside(v110));
+    CPPUNIT_ASSERT(s1.isInside(v210));
+    CPPUNIT_ASSERT(s1.isInside(v020));
+    CPPUNIT_ASSERT(s1.isInside(v120));
+    CPPUNIT_ASSERT(s1.isInside(v220));
+    CPPUNIT_ASSERT(s1.isInside(v001));
+    CPPUNIT_ASSERT(s1.isInside(v101));
+    CPPUNIT_ASSERT(s1.isInside(v201));
+    CPPUNIT_ASSERT(s1.isInside(v011));
+    CPPUNIT_ASSERT(s1.isInside(v111));
+    CPPUNIT_ASSERT(s1.isInside(v211));
+    CPPUNIT_ASSERT(s1.isInside(v021));
+    CPPUNIT_ASSERT(s1.isInside(v121));
+    CPPUNIT_ASSERT(s1.isInside(v221));
+    CPPUNIT_ASSERT(s1.isInside(v002));
+    CPPUNIT_ASSERT(s1.isInside(v102));
+    CPPUNIT_ASSERT(s1.isInside(v202));
+    CPPUNIT_ASSERT(s1.isInside(v012));
+    CPPUNIT_ASSERT(s1.isInside(v112));
+    CPPUNIT_ASSERT(s1.isInside(v212));
+    CPPUNIT_ASSERT(s1.isInside(v022));
+    CPPUNIT_ASSERT(s1.isInside(v122));
+    CPPUNIT_ASSERT(s1.isInside(v222));
+
+    Shape s2 = Everywhere() && Nowhere();
+    CPPUNIT_ASSERT(!s2.isInside(v000));
+    CPPUNIT_ASSERT(!s2.isInside(v100));
+    CPPUNIT_ASSERT(!s2.isInside(v200));
+    CPPUNIT_ASSERT(!s2.isInside(v010));
+    CPPUNIT_ASSERT(!s2.isInside(v110));
+    CPPUNIT_ASSERT(!s2.isInside(v210));
+    CPPUNIT_ASSERT(!s2.isInside(v020));
+    CPPUNIT_ASSERT(!s2.isInside(v120));
+    CPPUNIT_ASSERT(!s2.isInside(v220));
+    CPPUNIT_ASSERT(!s2.isInside(v001));
+    CPPUNIT_ASSERT(!s2.isInside(v101));
+    CPPUNIT_ASSERT(!s2.isInside(v201));
+    CPPUNIT_ASSERT(!s2.isInside(v011));
+    CPPUNIT_ASSERT(!s2.isInside(v111));
+    CPPUNIT_ASSERT(!s2.isInside(v211));
+    CPPUNIT_ASSERT(!s2.isInside(v021));
+    CPPUNIT_ASSERT(!s2.isInside(v121));
+    CPPUNIT_ASSERT(!s2.isInside(v221));
+    CPPUNIT_ASSERT(!s2.isInside(v002));
+    CPPUNIT_ASSERT(!s2.isInside(v102));
+    CPPUNIT_ASSERT(!s2.isInside(v202));
+    CPPUNIT_ASSERT(!s2.isInside(v012));
+    CPPUNIT_ASSERT(!s2.isInside(v112));
+    CPPUNIT_ASSERT(!s2.isInside(v212));
+    CPPUNIT_ASSERT(!s2.isInside(v022));
+    CPPUNIT_ASSERT(!s2.isInside(v122));
+    CPPUNIT_ASSERT(!s2.isInside(v222));
+  }
+
+}
Index: src/unittests/ShapeUnittest.hpp
===================================================================
--- src/unittests/ShapeUnittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/unittests/ShapeUnittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,66 @@
+/*
+ * ShapeUnittest.hpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef SHAPEUNITTEST_HPP_
+#define SHAPEUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class Shape;
+class Vector;
+
+#include "LinearAlgebra/Vector.hpp"
+
+class ShapeUnittest : public CppUnit::TestFixture
+{
+  CPPUNIT_TEST_SUITE( ShapeUnittest) ;
+  CPPUNIT_TEST ( baseShapesTest );
+  CPPUNIT_TEST ( assignmentTest );
+  CPPUNIT_TEST ( operatorTest );
+  CPPUNIT_TEST_SUITE_END();
+
+public:
+  void setUp();
+  void tearDown();
+
+  void baseShapesTest();
+  void assignmentTest();
+  void operatorTest();
+
+  // a lot of vectors.
+  // these define all the edges of a box around -1 +1 on each axis
+  // 0 is 0, 1 is 1 and 2 is -1
+  Vector v000;
+  Vector v100;
+  Vector v200;
+  Vector v010;
+  Vector v110;
+  Vector v210;
+  Vector v020;
+  Vector v120;
+  Vector v220;
+  Vector v001;
+  Vector v101;
+  Vector v201;
+  Vector v011;
+  Vector v111;
+  Vector v211;
+  Vector v021;
+  Vector v121;
+  Vector v221;
+  Vector v002;
+  Vector v102;
+  Vector v202;
+  Vector v012;
+  Vector v112;
+  Vector v212;
+  Vector v022;
+  Vector v122;
+  Vector v222;
+};
+
+#endif /* SHAPEUNITTEST_HPP_ */
Index: src/unittests/SingletonTest.cpp
===================================================================
--- src/unittests/SingletonTest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/SingletonTest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "SingletonTest.hpp"
Index: src/unittests/analysisbondsunittest.cpp
===================================================================
--- src/unittests/analysisbondsunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/analysisbondsunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -16,5 +21,4 @@
 #include <cstring>
 
-#include "World.hpp"
 #include "analysis_bonds.hpp"
 #include "analysisbondsunittest.hpp"
@@ -25,4 +29,5 @@
 #include "molecule.hpp"
 #include "periodentafel.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
 
@@ -52,26 +57,26 @@
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(1.5, 0., 1.5 );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(1.5, 0., 1.5 ));
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0., 1.5, 1.5 );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0., 1.5, 1.5 ));
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(1.5, 1.5, 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(1.5, 1.5, 0. ));
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0., 0., 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0., 0., 0. ));
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = carbon;
-  *Walker->node = Vector(0.5, 0.5, 0.5 );
+  Walker->setType(carbon);
+  Walker->setPosition(Vector(0.5, 0.5, 0.5 ));
   TestMolecule->AddAtom(Walker);
 
Index: src/unittests/atomsCalculationTest.cpp
===================================================================
--- src/unittests/atomsCalculationTest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/atomsCalculationTest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "atomsCalculationTest.hpp"
Index: src/unittests/atomsCalculationTest.hpp
===================================================================
--- src/unittests/atomsCalculationTest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/atomsCalculationTest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,6 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#define ATOM_COUNT (10)
+// we prefer enum over define
+enum { ATOM_COUNT = 10 };
 
 #include "types.hpp"
Index: src/unittests/bondgraphunittest.cpp
===================================================================
--- src/unittests/bondgraphunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/bondgraphunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -23,5 +28,5 @@
 #include "bondgraph.hpp"
 #include "element.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
@@ -54,24 +59,24 @@
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = carbon;
-  *Walker->node = Vector(1., 0., 1. );
+  Walker->setType(carbon);
+  Walker->setPosition(Vector(1., 0., 1. ));
   TestMolecule->AddAtom(Walker);
 
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = carbon;
-  *Walker->node = Vector(0., 1., 1. );
+  Walker->setType(carbon);
+  Walker->setPosition(Vector(0., 1., 1. ));
   TestMolecule->AddAtom(Walker);
 
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = carbon;
-  *Walker->node = Vector(1., 1., 0. );
+  Walker->setType(carbon);
+  Walker->setPosition(Vector(1., 1., 0. ));
   TestMolecule->AddAtom(Walker);
 
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = carbon;
-  *Walker->node = Vector(0., 0., 0. );
+  Walker->setType(carbon);
+  Walker->setPosition(Vector(0., 0., 0. ));
   TestMolecule->AddAtom(Walker);
 
Index: src/unittests/gslmatrixsymmetricunittest.cpp
===================================================================
--- src/unittests/gslmatrixsymmetricunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/gslmatrixsymmetricunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
Index: src/unittests/gslmatrixsymmetricunittest.hpp
===================================================================
--- src/unittests/gslmatrixsymmetricunittest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/gslmatrixsymmetricunittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,5 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "gslmatrix.hpp"
+#include "LinearAlgebra/gslmatrix.hpp"
 
 /********************************************** Test classes **************************************/
Index: src/unittests/gslmatrixunittest.cpp
===================================================================
--- src/unittests/gslmatrixunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/gslmatrixunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
Index: src/unittests/gslmatrixunittest.hpp
===================================================================
--- src/unittests/gslmatrixunittest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/gslmatrixunittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,5 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "gslmatrix.hpp"
+#include "LinearAlgebra/gslmatrix.hpp"
 
 /********************************************** Test classes **************************************/
Index: src/unittests/gslvectorunittest.cpp
===================================================================
--- src/unittests/gslvectorunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/gslvectorunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
Index: src/unittests/gslvectorunittest.hpp
===================================================================
--- src/unittests/gslvectorunittest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/gslvectorunittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,5 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "gslvector.hpp"
+#include "LinearAlgebra/gslvector.hpp"
 
 /********************************************** Test classes **************************************/
Index: src/unittests/infounittest.cpp
===================================================================
--- src/unittests/infounittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/infounittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -15,7 +20,7 @@
 #include <stdio.h>
 
-#include "info.hpp"
+#include "Helpers/Info.hpp"
 #include "infounittest.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 
 #ifdef HAVE_TESTRUNNER
Index: src/unittests/linearsystemofequationsunittest.cpp
===================================================================
--- src/unittests/linearsystemofequationsunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/linearsystemofequationsunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 using namespace std;
 
@@ -12,7 +17,8 @@
 #include <cppunit/extensions/TestFactoryRegistry.h>
 #include <cppunit/ui/text/TestRunner.h>
+#include <cmath>
 
 #include "linearsystemofequationsunittest.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 #ifdef HAVE_TESTRUNNER
Index: src/unittests/linearsystemofequationsunittest.hpp
===================================================================
--- src/unittests/linearsystemofequationsunittest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/linearsystemofequationsunittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,5 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "linearsystemofequations.hpp"
+#include "LinearAlgebra/linearsystemofequations.hpp"
 
 /********************************************** Test classes **************************************/
Index: src/unittests/listofbondsunittest.cpp
===================================================================
--- src/unittests/listofbondsunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/listofbondsunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: user
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -47,21 +52,21 @@
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(1., 0., 1. );
-  TestMolecule->AddAtom(Walker);
-  Walker = World::getInstance().createAtom();
-  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0., 1., 1. );
-  TestMolecule->AddAtom(Walker);
-  Walker = World::getInstance().createAtom();
-  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(1., 1., 0. );
-  TestMolecule->AddAtom(Walker);
-  Walker = World::getInstance().createAtom();
-  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0., 0., 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(1., 0., 1. ));
+  TestMolecule->AddAtom(Walker);
+  Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0., 1., 1. ));
+  TestMolecule->AddAtom(Walker);
+  Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(1., 1., 0. ));
+  TestMolecule->AddAtom(Walker);
+  Walker = World::getInstance().createAtom();
+  CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0., 0., 0. ));
   TestMolecule->AddAtom(Walker);
 
Index: src/unittests/logunittest.cpp
===================================================================
--- src/unittests/logunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/logunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -3,4 +3,9 @@
  */
 
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -11,7 +16,7 @@
 
 #include "logunittest.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "defs.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 
 #ifdef HAVE_TESTRUNNER
Index: src/unittests/manipulateAtomsTest.cpp
===================================================================
--- src/unittests/manipulateAtomsTest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/manipulateAtomsTest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "manipulateAtomsTest.hpp"
@@ -22,4 +27,6 @@
 #include "World.hpp"
 #include "atom.hpp"
+
+#include "DummyUI.hpp"
 
 #ifdef HAVE_TESTRUNNER
@@ -72,6 +79,13 @@
 // set up and tear down
 void manipulateAtomsTest::setUp(){
+  static bool hasDescriptor = false;
   ActionHistory::init();
   World::getInstance();
+  // TODO: find a way to really reset the factory to a clean state in tear-down
+  if(!hasDescriptor){
+    UIFactory::registerFactory(new DummyUIFactory::description());
+    hasDescriptor = true;
+  }
+  UIFactory::makeUserInterface("Dummy");
   for(int i=0;i<ATOM_COUNT;++i){
     atoms[i]= new AtomStub(i);
@@ -83,4 +97,5 @@
   ActionRegistry::purgeInstance();
   ActionHistory::purgeInstance();
+  UIFactory::purgeInstance();
 }
 
Index: src/unittests/manipulateAtomsTest.hpp
===================================================================
--- src/unittests/manipulateAtomsTest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/manipulateAtomsTest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,6 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#define ATOM_COUNT (10)
+// we prefer enum over define
+enum { ATOM_COUNT = 10 };
 
 class atom;
Index: src/unittests/memoryallocatorunittest.cpp
===================================================================
--- src/unittests/memoryallocatorunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/memoryallocatorunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -1,6 +1,12 @@
 /*
  * memoryallocatorunittest.cpp
+ *
  */
 
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -13,6 +19,6 @@
 #include "memoryallocatorunittest.hpp"
 #include "memoryusageobserver.hpp"
-#include "helpers.hpp"
-#include "log.hpp"
+#include "Helpers/helpers.hpp"
+#include "Helpers/Log.hpp"
 #include "defs.hpp"
 
Index: src/unittests/memoryusageobserverunittest.cpp
===================================================================
--- src/unittests/memoryusageobserverunittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/memoryusageobserverunittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -3,4 +3,9 @@
  */
 
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
Index: src/unittests/periodentafelTest.cpp
===================================================================
--- src/unittests/periodentafelTest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/periodentafelTest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 using namespace std;
 
@@ -11,4 +16,7 @@
 #include <cppunit/extensions/TestFactoryRegistry.h>
 #include <cppunit/ui/text/TestRunner.h>
+
+#include <sstream>
+#include <iostream>
 
 #include "Helpers/Assert.hpp"
@@ -67,5 +75,6 @@
 {
   // reload all databases
-  CPPUNIT_ASSERT(tafel->LoadElementsDatabase(new stringstream(elementsDB,ios_base::in)) && "General element initialization failed");
+  stringstream elementsDBstream(elementsDB,ios_base::in);
+  CPPUNIT_ASSERT(tafel->LoadElementsDatabase(elementsDBstream) && "General element initialization failed");
   CPPUNIT_ASSERT(tafel->LoadValenceDatabase(new stringstream(valenceDB,ios_base::in)) && "Valence entry of element initialization failed");
   CPPUNIT_ASSERT(tafel->LoadOrbitalsDatabase(new stringstream(orbitalsDB,ios_base::in)) && "Orbitals entry of element initialization failed");
